#include <algorithm>
#include <complex>
#include <iomanip>
#include <iostream>
#include <cassert>
#include <cmath>
#include <cstring>
#include <sstream>
#include "ovm.hpp"

using namespace std;

typedef complex<double> P;


void printVis(const string& name, int timestep, P pos, P vel) {
  cout << "VIS " << timestep << " "
       << name << " "
       << real(pos) << " " << imag(pos) << " "
       << 0 << " " << 0 << endl;
    //<< real(vel) << " " << imag(vel) << endl;
}

int main(int argc, char** argv) {
  cout.setf(ios::fixed);
  cout << setprecision(3);
  if (argc == 1) {
    printf("usage: %s 400[1234]\n", argv[0]);
    return 0;
  }
  OVM magi(atoi(argv[1]));
  magi.run();
  for (int i = 0; i < 100000; ++i) {
    magi.run();
    if (i % 1 == 0) {
      printVis("fate", magi.current_timestep(),
	       magi.current_fate_position(), magi.current_fate_velocity());
      printVis("moon", magi.current_timestep(),
	       magi.current_moon_position(), magi.current_moon_velocity());
      printVis("stat", magi.current_timestep(),
	       magi.current_station_position(), magi.current_station_velocity());
      for (int j = 0; j < 12; ++j) {
	ostringstream oss;
	oss << "hosi" << j;
	printVis(oss.str(), magi.current_timestep(),
		 magi.current_target_position(j),
		 magi.current_target_velocity(j));
      }
    }
  }
  
  
  return 0;
}
