import javax.swing.*;
import javax.swing.event.*;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;

import java.util.ArrayList;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@SuppressWarnings("serial")
public class VisualFate extends JFrame implements ChangeListener {

	// 悢q͐^_
	// vg^Cvpׂ̂Ăpublicɂpragma~Ǝv̍
	public JButton buttonOpen;
	public JSlider timeslider;
	public JSlider skipslider;
	public JLabel label;
	public OrbitVis graphic;
	public JPanel panelBase;

	public boolean running = false;
	public int t = 0;
	public int skip = 100;

	class Entity {
		public String name;
		public double x, y, vx, vy;

		public Entity(String line) {
			Scanner s = new Scanner(line);
			s.next();
			s.next();
			name = s.next();
			x = s.nextDouble();
			y = s.nextDouble();
			vx = s.nextDouble();
			vy = s.nextDouble();
		}
	}

	class TimeFrame {
		public TimeFrame() {
			es = new ArrayList<Entity>();
		}

		public ArrayList<Entity> es;
	}

	public ArrayList<TimeFrame> ts;

	public void loadLog(File file) {
		try {
			Scanner sc = new Scanner(new FileReader(file));
			sc.useDelimiter("[\n|\r]");
			Pattern p = Pattern.compile("^VIS\\s+(\\d+)");
			// format: VIS (name) (x) (y) (vx) (vy)
			while (sc.hasNextLine()) {
				String line = sc.nextLine();
				Matcher m = p.matcher(line);

				if (m.find()) {
					int frame = Integer.parseInt(m.group(1));
					while (ts.size() <= frame) {
						ts.add(new TimeFrame());
					}
					TimeFrame t = ts.get(frame);
					t.es.add(new Entity(line));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void whenOpenPressed() {
		JFileChooser filechooser = new JFileChooser();

		int selected = filechooser.showOpenDialog(panelBase);
		if (selected == JFileChooser.APPROVE_OPTION) {
			File file = filechooser.getSelectedFile();
			loadLog(file);
		}
	}

	public VisualFate() {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}

		panelBase = new JPanel();
		panelBase.setLayout(new BorderLayout(10, 10));

		buttonOpen = new JButton();
		buttonOpen.setText("open...");
		buttonOpen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				whenOpenPressed();
			}
		});
		JButton buttonRunStop = new JButton();
		buttonRunStop.setText("Run/Pause");
		buttonRunStop.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				running = !running;
			}
		});

		timeslider = new JSlider();
		timeslider.setPaintTicks(true);
		timeslider.setPaintLabels(true);
		timeslider.addChangeListener(this);
		
		skipslider = new JSlider();
		skipslider.setPaintTicks(true);
		skipslider.setPaintLabels(true);
		skipslider.setMinimum(1);
		skipslider.setMinimum(1000);
		skipslider.addChangeListener(new ChangeListener(){
			@Override
			public void stateChanged(ChangeEvent e) {
				skip = skipslider.getValue();
			}
		});
		
		JPanel southPanel;
		southPanel = new JPanel();
		southPanel.setLayout(new BoxLayout(southPanel, BoxLayout.X_AXIS));
		JPanel slidersPanel = new JPanel();
		slidersPanel.setLayout(new BoxLayout(slidersPanel, BoxLayout.Y_AXIS));
		slidersPanel.add(timeslider);
		slidersPanel.add(skipslider);
		southPanel.add(slidersPanel);
		southPanel.add(buttonRunStop);
		southPanel.add(buttonOpen);

		label = new JLabel("");
		label.setText("t = 0");

		ts = new ArrayList<TimeFrame>();
		graphic = new OrbitVis();

		panelBase.add(southPanel, BorderLayout.SOUTH);
		panelBase.add(label, BorderLayout.NORTH);
		panelBase.add(graphic, BorderLayout.CENTER);

		getContentPane().add(panelBase);

		class TimerListener implements ActionListener {
			public void actionPerformed(ActionEvent ae) {
				if (running) {
					label.setText("t = " + t);
					graphic.repaint();
					t += skip;
					if (t > ts.size())
						running = false;
				}
			}
		}
		javax.swing.Timer t = new javax.swing.Timer(200, new TimerListener());
		t.start();
	}

	@Override
	public void stateChanged(ChangeEvent arg0) {
		// TODO Auto-generated method stub

	}

	class OrbitVis extends JPanel {
		// 悢q(ry
		public final int size = 400;
		public final double earthr = 6.357e6;
		public int earthscale = 100;

		public OrbitVis() {
			setPreferredSize(new Dimension(size, size));
			setBackground(Color.white);
		}

		public void paintComponent(Graphics g) {
			super.paintComponent(g);
			g.setColor(Color.blue);
			g.fillOval(size / 2, size / 2, earthscale, earthscale);
			g.setColor(Color.green);
			if (ts == null || ts.size() == 0 || t >= ts.size())
				return;
			TimeFrame cur = ts.get(t);
			for (Entity e : cur.es) {
				int drawx = (int) (e.x / earthr * earthscale + size / 2);
				int drawy = (int) (e.y / earthr * earthscale + size / 2);
				g.drawOval(drawx, drawy, 3, 3);
				g.drawString(e.name, drawx, drawy);
			}
		}
	}

	public static void main(String[] args) {
		VisualFate o = new VisualFate();
		o.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		o.setTitle("ӂƂ݂̂ Ȃ̂͂͂Ⴞ");
		o.setBounds(0, 0, 600, 600);

		o.setVisible(true);
	}
}
