package jp.dip.icfp2009;

import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

public class VisualFateMain {

	static {
		// Set to the default Look and Feel here.
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		}
	}

	private static class VisualFateLauncher implements Runnable {
		private final VisualFateFrame frame;
		
		public VisualFateLauncher(VisualFateFrame frame) {
			if (frame == null) {
				throw new NullPointerException("Frame is null.");
			}
			this.frame = frame;
		}
		
		@Override
		public void run() {
			frame.setVisible(true);
		}
	}
	
	// Launcher
	public static void main(String[] args) {
		VisualFateDocument document = new VisualFateDocument();
		VisualFateFrame frame = new VisualFateFrame(document);
		SwingUtilities.invokeLater(new VisualFateLauncher(frame));
	}
}
